LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
 
ENTITY five_bit_tb IS
END five_bit_tb;
 
ARCHITECTURE behavior OF five_bit_tb IS 

    COMPONENT fivebit
    PORT(
         EKS : OUT  std_logic_vector(4 downto 0);
         res : IN  std_logic;
         clockk : IN  std_logic;
         SEL : IN  std_logic_vector(2 downto 0);
         INP : IN  std_logic_vector(4 downto 0)
        );
    END COMPONENT;
    
--SEL:
--000 : Reset /
--001 : Parallel loading /
--002 : Right shift /
--003 : Left shift /
--004 : Circular right shift /
--005 : Circular left shift /
--006 : 1s' complement /
--007 : 2s' complement

   --Inputs
   signal res : std_logic := '0';
   signal clockk : std_logic := '0';
   signal SEL : std_logic_vector(2 downto 0) := "000";
   signal INP : std_logic_vector(4 downto 0) := "11000";

 	--Outputs
   signal EKS : std_logic_vector(4 downto 0);

   -- Clock period definitions
   constant clockk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: fivebit PORT MAP (
          EKS => EKS,
          res => res,
          clockk => clockk,
          SEL => SEL,
          INP => INP
        );

   -- Clock process definitions
   clockk_process :process
   begin
		clockk <= '0';
		wait for clockk_period/2;
		clockk <= '1';
		wait for clockk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      wait for 100 ns;	
	SEL <= "001";
      wait for clockk_period;
	SEL <= "010";
      wait for clockk_period*4;
	SEL <= "011";
      wait for clockk_period*4;
	SEL <= "100";
      wait for clockk_period*8;
	SEL <= "101";
      wait for clockk_period*8;
	SEL <= "110";
      wait for clockk_period*8;
	SEL <= "111";
      wait for clockk_period*8;
	SEL <= "000";
      wait for clockk_period;
	SEL <= "001";
      wait;
   end process;

END;
